#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for VBD Library components
# C/C++ Compiler Used: 
# Produced By: Doug Gaer
# File Creation Date: 09/16/1999
# Date Last Modified: 03/31/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# This makefile contains all the build rules needed to compile 
# all the VBD library components.
# --------------------------------------------------------------- 

# Define the $(VBDDIR) macro in the main makefile for this application
# Setup path for VBD Base installation directory
# My directory path for the VBD class library.
# VBDDIR = $(VBDPATH)

# Define the $(PATHSEP) macro in the main makefile for this application
# Macro for path separator
# PATHSEP=/

# Define the $(OBJ_EXT) macro in the main makefile for this application
# Object file dot extension
# OBJ_EXT=.obj

# VBD source code path
# Any of these paths can be redefined in the main makefile for this
# application if another version of the source code was used
ASPRINT_PATH = $(VBDDIR)$(PATHSEP)src
BTREE_PATH = $(VBDDIR)$(PATHSEP)src
CACHE_PATH = $(VBDDIR)$(PATHSEP)src
CHSLIST_PATH = $(VBDDIR)$(PATHSEP)src
CONFIG_PATH = $(VBDDIR)$(PATHSEP)src
CRC32_PATH = $(VBDDIR)$(PATHSEP)src
DLLISTB_PATH = $(VBDDIR)$(PATHSEP)src
DTYPES_PATH = $(VBDDIR)$(PATHSEP)src
EHANDLER_PATH = $(VBDDIR)$(PATHSEP)src
HTMLDRV_PATH = $(VBDDIR)$(PATHSEP)src
PERSIST_PATH = $(VBDDIR)$(PATHSEP)src
PLACENEW_PATH = $(VBDDIR)$(PATHSEP)src
POD_PATH = $(VBDDIR)$(PATHSEP)src
PSCRIPT_PATH = $(VBDDIR)$(PATHSEP)src
QUEUE_PATH = $(VBDDIR)$(PATHSEP)src
REFCOUNT_PATH = $(VBDDIR)$(PATHSEP)src
SLLISTB_PATH = $(VBDDIR)$(PATHSEP)src
STACK_PATH = $(VBDDIR)$(PATHSEP)src
STRUTIL_PATH = $(VBDDIR)$(PATHSEP)src
USTRING_PATH = $(VBDDIR)$(PATHSEP)src
VBDFILE_PATH = $(VBDDIR)$(PATHSEP)src

# Rules to compile library components 
# ===============================================================
htmldrv$(OBJ_EXT):	$(HTMLDRV_PATH)$(PATHSEP)htmldrv.cpp $(HTMLDRV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(HTMLDRV_PATH)$(PATHSEP)htmldrv.cpp

btwalker$(OBJ_EXT):	$(BTREE_PATH)$(PATHSEP)btwalker.cpp $(BTWALKER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)btwalker.cpp

vbdstats$(OBJ_EXT):	$(VBDFILE_PATH)$(PATHSEP)vbdstats.cpp $(VBDSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBDFILE_PATH)$(PATHSEP)vbdstats.cpp

uint32$(OBJ_EXT):	$(DTYPES_PATH)$(PATHSEP)uint32.cpp $(UINT31_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DTYPES_PATH)$(PATHSEP)uint32.cpp

crc32$(OBJ_EXT):	$(CRC32_PATH)$(PATHSEP)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CRC32_PATH)$(PATHSEP)crc32.cpp

bucket$(OBJ_EXT):	$(CACHE_PATH)$(PATHSEP)bucket.cpp $(BUCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)bucket.cpp

cache$(OBJ_EXT):	$(CACHE_PATH)$(PATHSEP)cache.cpp $(CACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)cache.cpp

cacheb$(OBJ_EXT):	$(CACHE_PATH)$(PATHSEP)cacheb.cpp $(CACHEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)cacheb.cpp

chptrb$(OBJ_EXT):	$(CACHE_PATH)$(PATHSEP)chptrb.cpp $(CHPTRB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)chptrb.cpp

mnode$(OBJ_EXT):	$(BTREE_PATH)$(PATHSEP)mnode.cpp $(MNODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)mnode.cpp

entrykey$(OBJ_EXT):	$(BTREE_PATH)$(PATHSEP)entrykey.cpp $(ENTRYKEY_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)entrykey.cpp

btree$(OBJ_EXT):	$(BTREE_PATH)$(PATHSEP)btree.cpp $(BTREE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)btree.cpp

ehandler$(OBJ_EXT):	$(EHANDLER_PATH)$(PATHSEP)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.cpp

vbdfile$(OBJ_EXT):	$(VBDFILE_PATH)$(PATHSEP)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.cpp

ustring$(OBJ_EXT):	$(USTRING_PATH)$(PATHSEP)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(USTRING_PATH)$(PATHSEP)ustring.cpp

int32$(OBJ_EXT):	$(DTYPES_PATH)$(PATHSEP)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DTYPES_PATH)$(PATHSEP)int32.cpp

sllistb$(OBJ_EXT):	$(SLLISTB_PATH)$(PATHSEP)sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.cpp

dllistb$(OBJ_EXT):	$(DLLISTB_PATH)$(PATHSEP)dllistb.cpp $(DLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DLLISTB_PATH)$(PATHSEP)dllistb.cpp

vbdref$(OBJ_EXT):	$(VBDFILE_PATH)$(PATHSEP)vbdref.cpp $(VBDREF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBDFILE_PATH)$(PATHSEP)vbdref.cpp

pod$(OBJ_EXT):	$(POD_PATH)$(PATHSEP)pod.cpp $(POD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(POD_PATH)$(PATHSEP)pod.cpp

persist$(OBJ_EXT):	$(PERSIST_PATH)$(PATHSEP)persist.cpp $(PERSIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(PERSIST_PATH)$(PATHSEP)persist.cpp

chslist$(OBJ_EXT):	$(CHSLIST_PATH)$(PATHSEP)chslist.cpp $(CHSLIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CHSLIST_PATH)$(PATHSEP)chslist.cpp

config$(OBJ_EXT):	$(CONFIG_PATH)$(PATHSEP)config.cpp $(CONFIG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CONFIG_PATH)$(PATHSEP)config.cpp

strutil$(OBJ_EXT):	$(STRUTIL_PATH)$(PATHSEP)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(STRUTIL_PATH)$(PATHSEP)strutil.cpp

asprint$(OBJ_EXT):	$(ASPRINT_PATH)$(PATHSEP)asprint.cpp $(ASPRINT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(ASPRINT_PATH)$(PATHSEP)asprint.cpp

btwalk$(OBJ_EXT):	$(BTREE_PATH)$(PATHSEP)btwalk.cpp $(BTWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)btwalk.cpp

pscript$(OBJ_EXT):	$(PSCRIPT_PATH)$(PATHSEP)pscript.cpp $(PSCRIPT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(PSCRIPT_PATH)$(PATHSEP)pscript.cpp
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
