#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Watcom 10
# Produced By: Heiko Weber
# File Creation Date: 04/15/1999
# Date Last Modified: 04/22/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       d2     -- Enable debugging (full symbolic)
#       mf     -- flat (32bit) model
#       w4     -- Turn on warnings (maximum)
#       e25    -- Limit errors to 25
#       zq     -- operate quietly
#       bt=dos -- target operating system
#       otexan -- control optimization (maximum)
#       5r     -- pentium, register based calling
#       xs     -- allow exceptions
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
DTREE_PATH = 
CACHE_PATH = ..\..\src\
EHANDLER_PATH = ..\..\src\
DTYPES_PATH = ..\..\src\
VBDFILE_PATH = ..\..\src\
REFCOUNT_PATH = ..\..\src\
PLACENEW_PATH = ..\..\src\
CRC32_PATH = ..\..\src\

ADD_INC_PATHS = -I..\..\include -I.\

# Alloaction method used to reclaim deleted blocks
DEF_VB_ALLOC = /D__RECLAIM_BEST_FIT__ 
#DEF_VB_ALLOC = /D__RECLAIM_FIRST_FIT__ 

# Use this DEFMACS macro to compile without using template classes
DEFMACS = /D__NOT_USING_TEMPLATE_CLASS__ /D__DTREE_NODE__ /D__CONSOLE__ &
/D__USE_VBDREFCOUNT__ $(DEF_VB_ALLOC) # /DCPP_EXCEPTIONS

# Enable to use the template classes
# DEFMACS = /D__CONSOLE__ $(DEF_VB_ALLOC) # /DCPP_EXCEPTIONS

# Define macros for compiler and linker
CC = wcl386 -cc
CPP = wcl386 -cc++
LINKER = wcl386

# Define compiler and linker flags macros
CFLAGS= -w4 -e25 -zq -otexan -d2 -5r -bt=dos -mf $(ADD_INC_PATHS) $(DEFMACS) # -xs
COMPILE_ONLY = /c
LFLAGS =  

# Build dependency rules
# ===============================================================
CRC32_DEP = ..\..\include\crc32.h ..\..\include\crc32tab.h

UINT32_DEP = ..\..\include\dtypes.h ..\..\include\ehandler.h &
	..\..\include\uint32.h

BUCKET_DEP = ..\..\include\bucket.h ..\..\include\cacheb.h &
	..\..\include\cactype.h ..\..\include\ehandler.h &
	..\..\include\vbdfile.h $(DTREE_PATH)tnode.h &
	..\..\include\refcount.h $(DTREE_PATH)fkey.h &
	..\..\include\uint32.h

CACHE_DEP = ..\..\include\bucketb.h ..\..\include\cacheb.h &
	..\..\include\cactype.h ..\..\include\ehandler.h &
	..\..\include\vbdfile.h $(DTREE_PATH)tnode.h &
	..\..\include\refcount.h $(DTREE_PATH)fkey.h &
	..\..\include\uint32.h

CACHEB_DEP = ..\..\include\bucketb.h ..\..\include\cacheb.h &
	..\..\include\ehandler.h ..\..\include\vbdfile.h &
	..\..\include\refcount.h ..\..\include\int32.h &
	..\..\include\dtypes.h ..\..\include\uint32.h

CACSTATS_DEP = ..\..\include\bucketb.h ..\..\include\cacheb.h &
	..\..\include\ehandler.h ..\..\include\vbdfile.h &
	..\..\include\refcount.h ..\..\include\int32.h &
	..\..\include\dtypes.h ..\..\include\cacstats.h &
	..\..\include\uint32.h

CHPTRB_DEP = ..\..\include\bucket.h ..\..\include\bucketb.h &
	..\..\include\cache.h ..\..\include\cacheb.h &
	..\..\include\chptrb.h ..\..\include\cactype.h&
	..\..\include\ehandler.h ..\..\include\vbdfile.h &
	..\..\include\refcount.h ..\..\include\int32.h &
	..\..\include\dtypes.h ..\..\include\uint32.h

TNODE_DEP = $(DTREE_PATH)tnode.h ..\..\include\cacheptr.h &
	..\..\include\chptrb.h ..\..\include\cache.h &
	..\..\include\placenew.h ..\..\include\bucket.h &
	..\..\include\bucketb.h ..\..\include\cacheb.h &
	..\..\include\vbdfile.h ..\..\include\refcount.h &
	..\..\include\ehandler.h ..\..\include\int32.h &
	..\..\include\dtypes.h $(DTREE_PATH)fkey.h &
	..\..\include\uint32.h

FKEY_DEP = $(DTREE_PATH)tnode.h ..\..\include\cacheptr.h &
	..\..\include\chptrb.h ..\..\include\cache.h &
	..\..\include\placenew.h ..\..\include\bucket.h &
	..\..\include\bucketb.h ..\..\include\cacheb.h &
	..\..\include\vbdfile.h ..\..\include\refcount.h &
	..\..\include\cactype.h ..\..\include\ehandler.h &
	..\..\include\int32.h ..\..\include\dtypes.h &
	$(DTREE_PATH)fkey.h ..\..\include\uint32.h

DTREE_DEP = ..\..\include\bucket.h ..\..\include\bucketb.h &
	..\..\include\cache.h ..\..\include\cacheb.h &
	..\..\include\chptrb.h ..\..\include\cactype.h&
	..\..\include\cacheptr.h $(DTREE_PATH)dtree.h &
	..\..\include\ehandler.h ..\..\include\vbdfile.h &
	..\..\include\refcount.h ..\..\include\placenew.h &
	$(DTREE_PATH)tnode.h ..\..\include\int32.h&
	..\..\include\dtypes.h $(DTREE_PATH)fkey.h &
	..\..\include\uint32.h

EHANDLER_DEP = ..\..\include\ehandler.h

INT32_DEP = ..\..\include\dtypes.h ..\..\include\ehandler.h &
	..\..\include\int32.h

VBDFILE_DEP = ..\..\include\dtypes.h ..\..\include\ehandler.h &
	..\..\include\int32.h ..\..\include\vbdfile.h &
	..\..\include\refcount.h ..\..\include\uint32.h &
	..\..\include\crc32.h

VBDREF_DEP = ..\..\include\vbdfile.h &
	..\..\include\vbdref.h ..\..\include\refcount.h

TESTPROG_DEP = ..\..\include\bucket.h ..\..\include\bucketb.h &
	..\..\include\cache.h ..\..\include\cacheb.h &
	..\..\include\chptrb.h ..\..\include\cacheptr.h &
	..\..\include\cactype.h $(DTREE_PATH)dtree.h &
	..\..\include\ehandler.h ..\..\include\int32.h &
        ..\..\include\vbdfile.h ..\..\include\refcount.h &
	..\..\include\placenew.h $(DTREE_PATH)tnode.h &
	$(DTREE_PATH)fkey.h ..\..\include\uint32.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

uint32.obj:	$(DTYPES_PATH)uint32.cpp $(UINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)uint32.cpp

crc32.obj:	$(CRC32_PATH)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CRC32_PATH)crc32.cpp

bucket.obj:	$(CACHE_PATH)bucket.cpp $(BUCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)bucket.cpp

cache.obj:	$(CACHE_PATH)cache.cpp $(CACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cache.cpp

cacheb.obj:	$(CACHE_PATH)cacheb.cpp $(CACHEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cacheb.cpp

chptrb.obj:	$(CACHE_PATH)chptrb.cpp $(CHPTRB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)chptrb.cpp

cacstats.obj:	$(CACHE_PATH)cacstats.cpp $(CACSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cacstats.cpp

tnode.obj:	$(DTREE_PATH)tnode.cpp $(TNODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTREE_PATH)tnode.cpp

fkey.obj:	$(DTREE_PATH)fkey.cpp $(FKEY_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTREE_PATH)fkey.cpp

dtree.obj:	$(DTREE_PATH)dtree.cpp $(DTREE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTREE_PATH)dtree.cpp

ehandler.obj:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(EHANDLER_PATH)ehandler.cpp

int32.obj:	$(DTYPES_PATH)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)int32.cpp

vbdfile.obj:    $(VBDFILE_PATH)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(VBDFILE_PATH)vbdfile.cpp

vbdref.obj:	$(VBDFILE_PATH)vbdref.cpp $(VBDREF_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(VBDFILE_PATH)vbdref.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

# Make the executable
OBJS = cacheb.obj chptrb.obj dtree.obj ehandler.obj vbdfile.obj &
	testprog.obj tnode.obj int32.obj bucket.obj cache.obj &
	fkey.obj vbdref.obj cacstats.obj crc32.obj uint32.obj
 
$(PROJECT).exe:	$(OBJS)
	$(LINKER) $(LFLAGS) $(OBJS) -fe=$@ 
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .ERR files from working directory...
	if exist *.err del *.err  

	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 

	@echo Removing any test files created during program execution
	if exist *.dtx del *.dtx
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


