#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Borland C++ Builder 4.0
# Produced By: Doug Gaer
# File Creation Date: 08/05/1999 
# Date Last Modified: 09/15/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT1 = testi32
PROJECT2 = testu32
PROJECT3 = testi16
PROJECT4 = testu16
PROJECT5 = testf64

# Setup additional paths for includes and source code
DTYPES_PATH = ../../src/
EHANDLER_PATH = ../../src/

ADD_INC_PATHS = -I../../include

# Setup define macros
DEFMACS = -D__BCC_BUILDER_40__  -D__X86__ -D__CONSOLE__ \
-D__USE_DTYPES_CONSTANTS__

# Compile using native data types
DEFMACS1 = -D__USE_NATIVE_INT_TYPES__ -D__USE_NATIVE_FLOAT_TYPES__

# Compile without defining the platform independent data types
DEFMACS2 = -D__DO_NOT_DEFINE_INT_TYPES__ -D__DO_NOT_DEFINE_FLOAT_TYPES__

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
CFLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS) # $(DEFMACS1) # $(DEFMACS2)
COMPILE_ONLY = /c
LFLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ../../include/ehandler.h

INT32_DEP = ../../include/int32.h ../../include/ehandler.h \
	../../include/dtypes.h

UINT32_DEP = ../../include/uint32.h ../../include/ehandler.h \
	../../include/dtypes.h

INT16_DEP = ../../include/int16.h ../../include/ehandler.h \
	../../include/dtypes.h

UINT16_DEP = ../../include/uint16.h ../../include/ehandler.h \
	../../include/dtypes.h

FLOAT64_DEP = ../../include/float64.h ../../include/ehandler.h \
	../../include/dtypes.h 

TESTI32_DEP = ../../include/int32.h ../../include/ehandler.h \
	../../include/dtypes.h

TESTU32_DEP = ../../include/uint32.h ../../include/ehandler.h \
	../../include/dtypes.h

TESTI16_DEP = ../../include/int16.h ../../include/ehandler.h \
	../../include/dtypes.h

TESTU16_DEP = ../../include/uint16.h ../../include/ehandler.h \
	../../include/dtypes.h

TESTF64_DEP = ../../include/float64.h ../../include/ehandler.h \
	../../include/dtypes.h 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT1).exe $(PROJECT2).exe $(PROJECT3).exe $(PROJECT4).exe \
	$(PROJECT5).exe

int32.obj:	$(DTYPES_PATH)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)int32.cpp

uint32.obj:	$(DTYPES_PATH)uint32.cpp $(UINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)uint32.cpp

int16.obj:	$(DTYPES_PATH)int16.cpp $(INT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)int16.cpp

uint16.obj:	$(DTYPES_PATH)uint16.cpp $(UINT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)uint16.cpp

float64.obj:	$(DTYPES_PATH)float64.cpp $(FLOAT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)float64.cpp

ehandler.obj:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(EHANDLER_PATH)ehandler.cpp

testf64.obj:	testf64.cpp $(TESTF64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testf64.cpp

testu16.obj:	testu16.cpp $(TESTU16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testu16.cpp

testi16.obj:	testi16.cpp $(TESTI16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testi16.cpp

testu32.obj:	testu32.cpp $(TESTU32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testu32.cpp

testi32.obj:	testi32.cpp $(TESTI32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testi32.cpp

# Make the executable
OBJS_PROJECT1 = ehandler.obj testi32.obj int32.obj 
OBJS_PROJECT2 = ehandler.obj testu32.obj uint32.obj 
OBJS_PROJECT3 = ehandler.obj testi16.obj int16.obj 
OBJS_PROJECT4 = ehandler.obj testu16.obj uint16.obj 
OBJS_PROJECT5 = ehandler.obj testf64.obj float64.obj 

# BCC 32 libs needed to build console applications
ALLOBJ1 = c0x32.obj $(OBJS_PROJECT1)
ALLOBJ2 = c0x32.obj $(OBJS_PROJECT2)
ALLOBJ3 = c0x32.obj $(OBJS_PROJECT3)
ALLOBJ4 = c0x32.obj $(OBJS_PROJECT4)
ALLOBJ5 = c0x32.obj $(OBJS_PROJECT5)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT1).exe:	$(OBJS_PROJECT1)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ1), +
	$(PROJECT1),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!

$(PROJECT2).exe:	$(OBJS_PROJECT2)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ2), +
	$(PROJECT2),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!

$(PROJECT3).exe:	$(OBJS_PROJECT3)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ3), +
	$(PROJECT3),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!

$(PROJECT4).exe:	$(OBJS_PROJECT4)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ4), +
	$(PROJECT4),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!

$(PROJECT5).exe:	$(OBJS_PROJECT5)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ5), +
	$(PROJECT5),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT1).exe del $(PROJECT1).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT2).exe del $(PROJECT2).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT3).exe del $(PROJECT3).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT4).exe del $(PROJECT4).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT5).exe del $(PROJECT5).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


