#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Borland C++ Builder 4.0
# Produced By: Doug Gaer
# File Creation Date: 08/05/1999 
# Date Last Modified: 09/02/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
PERSIST_PATH = ../../src/
POD_PATH = ../../src/
EHANDLER_PATH = ../../src/
DTYPES_PATH = ../../src/
VBDFILE_PATH = ../../src/
USTRING_PATH = ../../src/
REFCOUNT_PATH = ../../src/
BTREE_PATH = ../../src/
CACHE_PATH = ../../src/
PLACENEW_PATH = ../../src/
CRC32_PATH = ../../src/
STRUTIL_PATH = ../../src/

ADD_INC_PATHS = -I../../include

# Alloaction method used to reclaim deleted blocks
DEF_VB_ALLOC = -D__RECLAIM_BEST_FIT__ 
#DEF_VB_ALLOC = -D__RECLAIM_FIRST_FIT__ 

# Setup define macros
DEFMACS = -D__DOS__ -D__X86__ -D__CONSOLE__ $(DEF_VB_ALLOC) \
-D__BCC_BUILDER_40__ # -DCPP_EXCEPTIONS

# Use this DEFMACS macro to compile without using template classes
# DEFMACS = -D__NOT_USING_TEMPLATE_CLASS__ -D__BTREE_MNODE__ -D__CONSOLE__ \
# -D__USE_VBDREFCOUNT__ -D__DOS__ -D__X86__ $(DEF_VB_ALLOC) \
# -D__BCC_BUILDER_40__ # -DCPP_EXCEPTIONS

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
CFLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LFLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
CRC32_DEP = ../../include/crc32.h ../../include/crc32tab.h

UINT32_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/uint32.h

BUCKET_DEP = ../../include/bucket.h ../../include/cacheb.h \
	../../include/cactype.h ../../include/ehandler.h \
	../../include/vbdfile.h ../../include/mnode.h \
	../../include/refcount.h ../../include/uint32.h

CACHE_DEP = ../../include/bucketb.h ../../include/cacheb.h \
	../../include/cactype.h ../../include/ehandler.h \
	../../include/vbdfile.h ../../include/mnode.h \
	../../include/refcount.h ../../include/uint32.h

CACHEB_DEP = ../../include/bucketb.h ../../include/cacheb.h \
	../../include/ehandler.h ../../include/vbdfile.h \
	../../include/refcount.h ../../include/int32.h \
	../../include/dtypes.h ../../include/uint32.h

CACSTATS_DEP = ../../include/bucketb.h ../../include/cacheb.h \
	../../include/ehandler.h ../../include/vbdfile.h \
	../../include/refcount.h ../../include/int32.h \
	../../include/dtypes.h ../../include/cacstats.h \
	../../include/uint32.h

CHPTRB_DEP = ../../include/bucket.h ../../include/bucketb.h \
	../../include/cache.h ../../include/cacheb.h \
	../../include/chptrb.h ../../include/cactype.h\
	../../include/ehandler.h ../../include/vbdfile.h \
	../../include/refcount.h ../../include/int32.h \
	../../include/dtypes.h ../../include/uint32.h

MNODE_DEP = ../../include/mnode.h ../../include/ehandler.h \
	../../include/int32.h ../../include/dtypes.h \
	../../include/entrykey.h

ENTRYKEY_DEP = ../../include/entrykey.h ../../include/ehandler.h \
	../../include/int32.h ../../include/dtypes.h \
	../../include/strutil.h 

STRUTIL_DEP = ../../include/strutil.h

BTREE_DEP = ../../include/bucket.h ../../include/bucketb.h \
	../../include/cache.h ../../include/cacheb.h \
	../../include/chptrb.h ../../include/cactype.h\
	../../include/cacheptr.h ../../include/btree.h \
	../../include/ehandler.h ../../include/vbdfile.h \
	../../include/refcount.h ../../include/placenew.h \
	../../include/mnode.h ../../include/int32.h\
	../../include/dtypes.h ../../include/entrykey.h \
	../../include/uint32.h

BTREEPRT_DEP = ../../include/bucket.h 	../../include/bucketb.h \
	../../include/cache.h 	../../include/cacheb.h \
	../../include/chptrb.h ../../include/cactype.h\
	../../include/cacheptr.h ../../include/btree.h \
	../../include/ehandler.h ../../include/vbdfile.h \
	../../include/refcount.h ../../include/placenew.h \
	../../include/mnode.h ../../include/int32.h\
	../../include/dtypes.h ../../include/entrykey.h \
	../../include/btreeprt.h ../../include/uint32.h

EHANDLER_DEP = ../../include/ehandler.h

FLOAT64_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/float64.h

INT32_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/int32.h

VBDFILE_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/int32.h ../../include/vbdfile.h \
	../../include/refcount.h ../../include/crc32.h \
	../../include/uint32.h

VBDREF_DEP = ../../include/vbdfile.h ../../include/vbdref.h \
	../../include/refcount.h

POD_DEP = ../../include/pod.h ../../include/bucket.h \
	../../include/bucketb.h ../../include/cache.h \
	../../include/cacheb.h ../../include/chptrb.h \
	../../include/cactype.h ../../include/cacheptr.h \
	../../include/btree.h ../../include/ehandler.h \
	../../include/vbdfile.h ../../include/refcount.h \
	../../include/placenew.h ../../include/mnode.h \
	../../include/int32.h ../../include/dtypes.h \
	../../include/entrykey.h ../../include/btree.h \
	../../include/uint32.h

PERSIST_DEP = ../../include/pod.h ../../include/bucket.h \
	../../include/bucketb.h ../../include/cache.h \
	../../include/cacheb.h ../../include/chptrb.h \
	../../include/cactype.h ../../include/cacheptr.h \
	../../include/btree.h ../../include/ehandler.h \
	../../include/vbdfile.h ../../include/refcount.h \
	../../include/placenew.h ../../include/mnode.h \
	../../include/int32.h ../../include/dtypes.h \
	../../include/entrykey.h ../../include/btree.h \
	../../include/persist.h ../../include/uint32.h 

PART_DEP = ../../include/pod.h ../../include/bucket.h \
	../../include/bucketb.h ../../include/cache.h \
	../../include/cacheb.h ../../include/chptrb.h \
	../../include/cactype.h ../../include/cacheptr.h \
	../../include/btree.h ../../include/ehandler.h \
	../../include/vbdfile.h ../../include/refcount.h \
	../../include/placenew.h ../../include/mnode.h \
	../../include/int32.h ../../include/dtypes.h \
	../../include/entrykey.h ../../include/btree.h \
	../../include/persist.h part.h ../../include/uint32.h 

USTRING_DEP = ../../include/ustring.h 

TESTPROG_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/float64.h ../../include/int32.h \
        ../../include/vbdfile.h ../../include/refcount.h \
	../../include/ustring.h ../../include/pod.h \
	../../include/bucket.h ../../include/bucketb.h \
	../../include/cache.h ../../include/cacheb.h \
	../../include/chptrb.h ../../include/cacheptr.h \
	../../include/cactype.h ../../include/btree.h \
	../../include/placenew.h ../../include/mnode.h \
	../../include/entrykey.h ../../include/btreeprt.h \
	../../include/cacstats.h ../../include/pod.h \
	../../include/persist.h part.h ../../include/uint32.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

strutil.obj:	$(STRUTIL_PATH)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(STRUTIL_PATH)strutil.cpp 

uint32.obj:	$(DTYPES_PATH)uint32.cpp $(UINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)uint32.cpp

crc32.obj:	$(CRC32_PATH)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CRC32_PATH)crc32.cpp

bucket.obj:	$(CACHE_PATH)bucket.cpp $(BUCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)bucket.cpp

cache.obj:	$(CACHE_PATH)cache.cpp $(CACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cache.cpp

cacheb.obj:	$(CACHE_PATH)cacheb.cpp $(CACHEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cacheb.cpp

chptrb.obj:	$(CACHE_PATH)chptrb.cpp $(CHPTRB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)chptrb.cpp

cacstats.obj:	$(CACHE_PATH)cacstats.cpp $(CACSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cacstats.cpp

mnode.obj:	$(BTREE_PATH)mnode.cpp $(MNODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(BTREE_PATH)mnode.cpp

entrykey.obj:	$(BTREE_PATH)entrykey.cpp $(ENTRYKEY_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BTREE_PATH)entrykey.cpp

btreeprt.obj:	$(BTREE_PATH)btreeprt.cpp $(BTREEPRT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BTREE_PATH)btreeprt.cpp

btree.obj:	$(BTREE_PATH)btree.cpp $(BTREE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BTREE_PATH)btree.cpp

vbdref.obj:	$(VBDFILE_PATH)vbdref.cpp $(VBDREF_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(VBDFILE_PATH)vbdref.cpp

ehandler.obj:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(EHANDLER_PATH)ehandler.cpp

float64.obj:	$(DTYPES_PATH)float64.cpp $(FLOAT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)float64.cpp

int32.obj:	$(DTYPES_PATH)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)int32.cpp

vbdfile.obj:    $(VBDFILE_PATH)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(VBDFILE_PATH)vbdfile.cpp

pod.obj:    $(POD_PATH)pod.cpp $(POD_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(POD_PATH)pod.cpp

persist.obj:    $(PERSIST_PATH)persist.cpp $(PERSIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(PERSIST_PATH)persist.cpp

part.obj:	part.cpp $(PART_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) part.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

ustring.obj:	$(USTRING_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(USTRING_PATH)ustring.cpp

# Make the executable
OBJS = ehandler.obj float64.obj int32.obj vbdfile.obj \
	testprog.obj ustring.obj pod.obj cacheb.obj chptrb.obj \
	btree.obj mnode.obj bucket.obj cache.obj vbdref.obj \
	entrykey.obj btreeprt.obj cacstats.obj persist.obj \
	part.obj crc32.obj uint32.obj strutil.obj
 
# BCC 32 libs needed to build console applications
ALLOBJ = c0x32.obj $(OBJS)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT).exe:	$(OBJS)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ), +
	$(PROJECT),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 

	@echo Removing any test files created 
	if exist *.pod del *.pod

	@echo Removing any test files created 
	if exist *.btx del *.btx

	@echo Removing any test files created 
	if exist *.vbd del *.vbd
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


