#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the ASCII to PostScript converter program.
# C/C++ Compiler Used: Watcom 10
# Produced By: Heiko Weber
# File Creation Date: 04/15/1999
# Date Last Modified: 04/22/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       d2     -- Enable debugging (full symbolic)
#       mf     -- flat (32bit) model
#       w4     -- Turn on warnings (maximum)
#       e25    -- Limit errors to 25
#       zq     -- operate quietly
#       bt=dos -- target operating system
#       otexan -- control optimization (maximum)
#       5r     -- pentium, register based calling
#       xs     -- allow exceptions
#       Zp1    -- pack structures (default)
#
# NOTE: None of the Watcom compilers will expand wildcard characters
# used in command-line arguments unless compiled & linked with the
# wildargv.c module found in %(WATCOM)\SRC\STARTUP.
# All the UNIX compliers will expand wildcard characters by default.
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = as2ps

# Installation directory for the application and config files
INSTALL_DIR = ..\..\bin

# Macro for path separator
PATHSEP=\

# Setup additional paths for includes and source code
AS2PS_PATH = .
PSCRIPT_PATH = ..\..\src

ADD_INC_PATHS = -I..\..\include

# Setup define macros
DEFMACS = 

# Define macros for compiler and linker
CC = wcl386 -cc
CPP = wcl386 -cc++
LINKER = wcl386

# Define compiler and linker flags macros
CFLAGS= -w4 -e25 -zq -otexan -d2 -5r -bt=dos -mf $(ADD_INC_PATHS) $(DEFMACS) # -xs
COMPILE_ONLY = /c
LFLAGS =  

# Additional libraries
LIBRARIES =

# Build dependency rules
# ===============================================================
PSCRIPT_DEP = ..\..\include\pscript.h 

AS2PS_DEP = ..\..\include\pscript.h &
	$(AS2PS_PATH)$(PATHSEP)as2ps.h 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

wildargv.obj:	$(%WATCOM)$(PATHSEP)SRC$(PATHSEP)STARTUP$(PATHSEP)WILDARGV.C
	$(CC) $(COMPILE_ONLY) $(CFLAGS) $<

pscript.obj:	$(PSCRIPT_PATH)$(PATHSEP)pscript.cpp $(PSCRIPT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(PSCRIPT_PATH)$(PATHSEP)pscript.cpp

as2ps.obj:	$(AS2PS_PATH)$(PATHSEP)as2ps.cpp $(AS2PS_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(AS2PS_PATH)$(PATHSEP)as2ps.cpp

# Make the executable
OBJS = pscript.obj as2ps.obj wildargv.obj
 
$(PROJECT).exe:	$(OBJS)
	$(LINKER) $(LFLAGS) $(OBJS) $(LIBRARIES) -fe=$@ 
# ===============================================================

# ===============================================================
install:
	@echo Installing $(PROJECT) binaries to the bin directory...
	@if exist $(PROJECT).exe copy $(PROJECT).exe $(INSTALL_DIR)
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .ERR files from working directory...
	if exist *.err del *.err  

	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


