#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the VBD utility program
# C/C++ Compiler Used: Watcom 10
# Produced By: Heiko Weber
# File Creation Date: 04/15/1999
# Date Last Modified: 04/22/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       d2     -- Enable debugging (full symbolic)
#       mf     -- flat (32bit) model
#       w4     -- Turn on warnings (maximum)
#       e25    -- Limit errors to 25
#       zq     -- operate quietly
#       bt=dos -- target operating system
#       otexan -- control optimization (maximum)
#       5r     -- pentium, register based calling
#       xs     -- allow exceptions
#       Zp1    -- pack structures (default)
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = vb_debug

# Installation directory for the application and config files
INSTALL_DIR = ..\..\bin

# Macro for path separator
PATHSEP=\

# Setup additional paths for includes and source code
VB_DEBUG_PATH = .
EHANDLER_PATH = ..\..\src
DTYPES_PATH = ..\..\src
REFCOUNT_PATH = ..\..\src
VBDFILE_PATH = ..\..\src
CRC32_PATH = ..\..\src

ADD_INC_PATHS = -I..\..\include

# Setup define macros
DEFMACS = /D__CONSOLE__

# Define macros for compiler and linker
CC = wcl386 -cc
CPP = wcl386 -cc++
LINKER = wcl386

# Define compiler and linker flags macros
CFLAGS= -w4 -e25 -zq -otexan -d2 -5r -bt=dos -mf $(ADD_INC_PATHS) $(DEFMACS) # -xs
COMPILE_ONLY = /c
LFLAGS =  

# Build dependency rules
# ===============================================================
VBDFILE_DEP = ..\..\include\ehandler.h &
	..\..\include\vbdfile.h &
	..\..\include\refcount.h &
	..\..\include\dtypes.h &
	..\..\include\int32.h &
	..\..\include\uint32.h 

EHANDLER_DEP = ..\..\include\ehandler.h 

CRC32_DEP = ..\..\include\crc32.h &
	..\..\include\crc32tab.h 

VBDFILE_DEP = ..\..\include\ehandler.h &
	..\..\include\vbdfile.h &
	..\..\include\refcount.h &
	..\..\include\dtypes.h &
	..\..\include\int32.h &
	..\..\include\uint32.h &
	..\..\include\crc32.h 

INT32_DEP =  ..\..\include\ehandler.h &
	..\..\include\dtypes.h &
	..\..\include\int32.h

UINT32_DEP =  ..\..\include\ehandler.h &
	..\..\include\dtypes.h &
	..\..\include\uint32.h

VB_DEBUG_DEP = ..\..\include\ehandler.h &
	..\..\include\vbdfile.h &
	..\..\include\refcount.h &
	..\..\include\dtypes.h &
	..\..\include\int32.h &
	..\..\include\vbdstats.h &
	..\..\include\uint32.h 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

vbdstats.obj:	$(VBDFILE_PATH)$(PATHSEP)vbdstats.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(VBDFILE_PATH)$(PATHSEP)vbdstats.cpp

ehandler.obj:	$(EHANDLER_PATH)$(PATHSEP)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(EHANDLER_PATH)$(PATHSEP)ehandler.cpp

vbdfile.obj:	$(VBDFILE_PATH)$(PATHSEP)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.cpp

vb_debug.obj:	$(VB_DEBUG_PATH)$(PATHSEP)vb_debug.cpp $(VB_DEBUG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(VB_DEBUG_PATH)$(PATHSEP)vb_debug.cpp

int32.obj:	$(DTYPES_PATH)$(PATHSEP)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(DTYPES_PATH)$(PATHSEP)int32.cpp

uint32.obj:	$(DTYPES_PATH)$(PATHSEP)uint32.cpp $(UINT31_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(DTYPES_PATH)$(PATHSEP)uint32.cpp

crc32.obj:	$(CRC32_PATH)$(PATHSEP)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) &
	$(CRC32_PATH)$(PATHSEP)crc32.cpp

# Make the executable
OBJS = ehandler.obj vbdfile.obj vb_debug.obj int32.obj &
	uint32.obj crc32.obj vbdstats.obj
 
$(PROJECT).exe:	$(OBJS)
	$(LINKER) $(LFLAGS) $(OBJS) -fe=$@ 
# ===============================================================

# ===============================================================
install:
	@echo Installing $(PROJECT) binaries to the bin directory...
	@if exist $(PROJECT).exe copy $(PROJECT).exe $(INSTALL_DIR)
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .ERR files from working directory...
	if exist *.err del *.err  

	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


